<template lang="html">
  <div class="dashboard-game-view">
    <div class="dashboard-game-view-content"
      v-if="profile.isLoggedIn  && isAccessVerified && hasAccess">
      <ep-game-thumbnail
        :thumbnail="gameThumbnail"></ep-game-thumbnail>
      <ep-dashboard-game-header
        :gid="game.gid || ''"
        :title="game.title || ''"
        :privacy="game.privacy || ''"></ep-dashboard-game-header>
      <ep-dashboard-game-version-list
        :gid="game.gid || ''"
        :list="appVersions"
        v-on:get-app="getApp()"></ep-dashboard-game-version-list>
      <hr class="section-division">
      <input type="submit"
        id="deleteBtn"
        :value="label.DELETE"
        v-on:click="showAreYouSureDialog(label.ARE_YOU_SURE_DELETE, deleteGame)">
    </div>
    <ep-404 v-else-if="show404"></ep-404>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from 'vuex'

import Ep404 from '~components/404'
import GameThumbnail from '~components/Game/Thumbnail'
import DashboardGameHeader from '~components/Dashboard/GameHeader'
import DashboardGameVersionList from '~components/Dashboard/GameVersionList'

export default {
  name: 'ep-dashboard-game-view',
  components: {
    'ep-404': Ep404,
    'ep-game-thumbnail': GameThumbnail,
    'ep-dashboard-game-header': DashboardGameHeader,
    'ep-dashboard-game-version-list': DashboardGameVersionList
  },
  data () {
    return {
      game: {},
      hasAccess: false,
      isAccessVerified: false,
      appVersions: [],
      label: {
        DELETE: 'Delete',
        ARE_YOU_SURE_DELETE: 'Are you sure you would like to delete this game?'
      }
    }
  },
  computed: {
    ...mapState('app', [
      'show404'
    ]),
    ...mapGetters([
      'profile'
    ]),
    gameThumbnail () {
      if (this.game && this.game.media) {
        return this.game.media.thumbnail.source
      } else {
        return ''
      }
    }
  },
  watch: {
    '$route.params.gid' () {
      this.initData()
    }
  },
  mounted () {
    this.initData()
  },
  methods: {
    ...mapActions('app', [
      'show404Message'
    ]),
    initData () {
      let gid = this.$route.params.gid

      if (!gid) {
        this.show404Message()
        return
      }

      this.$store.dispatch('getProfileInfo')
      .then(() => {
        return this.$store.dispatch('verifyGameEditAccess', gid)
        .then(accessResponse => {
          this.hasAccess = accessResponse.hasAccess
          this.isAccessVerified = true

          if (!this.hasAccess) {
            return Promise.reject('User does not have access')
          }
        })
      })
      // Show nothing for profile retrieval or access errors
      .catch(err => {
        this.show404Message()
        return Promise.reject(`Error retrieving user profile or User is not valid: ${err}`)
      })
      .then(() => {
        return this.$store.dispatch('getGameByGIDWithForce', gid)
      })
      .then(gameResponse => {
        this.game = gameResponse
        return this.$store.dispatch('getGameApp', gameResponse.app.aid)
      })
      .then(appResponse => {
        this.setupAppVersions(appResponse)
      })
      .catch(err => {
        console.error(`Error while mounting dashboard game view: ${err}`)
      })
    },
    getApp () {
      return this.$store.dispatch('getGameApp', this.game.app.aid)
      .then(appResponse => {
        this.setupAppVersions(appResponse)
      })
    },
    setupAppVersions (app) {
      let appVersions = []

      for (let env in app.versionsActive) {
        let key = app.versionsActive[env]
        let envName = ''
        let isLive = false
        switch (env) {
          case 'prod':
            envName = 'Live'
            isLive = true
            break
          case 'dev':
            envName = 'Stage'
            break
          default: envName = 'Stage'
        }

        appVersions.push({
          uid: app.versions[key].uid,
          name: app.versions[key].title,
          env: envName,
          originalEnv: env,
          isLive
        })
      }

      this.appVersions = appVersions

      this.getAppStatus()
    },
    getAppStatus () {
      // Copy appVersions
      let appVersions = this.appVersions.slice()

      // Get status
      return this.$store.dispatch('getGameAppStatus', this.game.app.aid)
      .then(statusResponse => {
        for (let i = 0; i < appVersions.length; i++) {
          let hostDetailsStatus = statusResponse.versionsActive[appVersions[i].originalEnv].hostDetailsStatus
          appVersions[i].status = hostDetailsStatus.label || ''
          appVersions[i].message = hostDetailsStatus.message || ''
          appVersions[i].buildLogDetails = hostDetailsStatus.buildLogDetails
          appVersions[i].runtimeLogDetails = hostDetailsStatus.runtimeLogDetails
        }

        // Update app versions
        this.appVersions = appVersions
      })
    },
    deleteGame () {
      this.$store.dispatch('deleteGame', this.game.gid)
      .then(() => {
        this.navigateToDashboard()
      })
      .catch(err => {
        console.error(`Error deleting game :${err}`)
      })
    },
    navigateToDashboard () {
      this.$router.push({
        name: 'dashboard'
      })
    },
    showAreYouSureDialog (message, callback) {
      this.$emit('are-you-sure', {
        message,
        callback
      })
    },
    showDialog (option) {
      this.$emit('dialog-selected', option)
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/theme';
@import '~assets/styles/input';

.dashboard-game-view-content {
  display: block;
  position: relative;
  margin: 0;
  padding: 16px;
  border-right: none;
  border-left: none;
  border-bottom: 1px solid #dcdcdc;
}

#deleteBtn {
  background-color: $orange;
}

.content {
  margin-top: 20px;
}

.section-division {
  margin: 24px 0;
  border: none;
  border-bottom: 1px solid $dark-gray;
}

.nothing-here-message {
  padding: 20px;
}
</style>
